function lvmrep_log_alload() {
  let data = {
    cmd: 'lv_snap_tasks',
    token: UToken
  }
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      if (res.err == 0) {
        jQuery('#jv-lvmbdrloghost').empty();
        var log = res.results.log || {};
        var task = res.results.task || {};
        var records = log.clone.c || [];
        var title = log.clone.title || [];

        for (var i = 0; i < records.length; i++) {
          var t_p = records[i];
          var logdom = lvmTemplateAppend('#jv-lvmbdrloghost', 'jvt-logitem', 'jvt-logitem-' + i);
          if (task[t_p[2]]) {
            logdom.find('.logname').text(task[t_p[2]].taskname || '--');
          }else {
            logdom.find('.logname').text(t_p[2] || '--');
          }

          logdom.find('.jvc-from').text(t_p[5] || '--');
          logdom.find('.logtime').text(formatDate_vm(t_p[0]) || '--');
          logdom.find('.jvc-to').text(t_p[6] || '--');
          logdom.find('.jvc-level').text(t_p[4]).addClass('level-' + t_p[4]);
          logdom.find('.jvc-info').text(t_p[7]);
          logdom.attr('line', i);

          logdom.find('input[type="checkbox"]').on('click', function() {
            var s_len = jQuery('#jv-lvmbdrloghost').children().length;
            var c_len = jQuery('#jv-lvmbdrloghost input[type="checkbox"]:checked').length;
            if (c_len) {
              jQuery('#jv-lvmlogcancelbtn').removeClass('layui-disabled');
            } else {
              jQuery('#jv-lvmlogcancelbtn').addClass('layui-disabled');
            }

          })

          logdom.find('.unas_icon_delete').on('click', function() {
            var pnode = jQuery(this).closest('tr');
            var line = +pnode.attr('line');
            th_alertWindowFn({
              tips: UNAS._("Are you sure to delete log?")
            }, function() {
              lvmrep_log_clear([line]);
            })

          })
        }
      }

      jQuery('#jv-lvmselalllog').prop('checked', false);

      lvmTranslator('jv-lvmbdrloghost');
    },
    complete: function() {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function lvmrep_log_clear(lines) {
  let data = {
    cmd: 'lv_snap_log_rm',
    token: UToken,
    params: {
      "type": "clone",
      lines: lines
    }
  }

  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      if (res.err == 0) {
        lvmrep_log_alload();
      }
    },
    complete: function() {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

jQuery(document).ready(function() {
  lvmrep_log_alload();
  jQuery('#jv-lvmselalllog').on('click', function() {
    var s_len = jQuery('#jv-lvmbdrloghost').children().length;
    if (this.checked && s_len) {
      jQuery('#jv-lvmbdrloghost input[type="checkbox"]').prop('checked', true);
      jQuery('#jv-lvmlogcancelbtn').removeClass('layui-disabled');
    } else {
      jQuery('#jv-lvmbdrloghost input[type="checkbox"]').prop('checked', false);
      jQuery('#jv-lvmlogcancelbtn').addClass('layui-disabled');
    }
  })

  jQuery('#jv-searchlvmlog').bind('input propertychange', function(e) {
    var v = jQuery(this).val();
    jQuery('#jv-lvmbdrloghost tr').hide().filter(":contains('" + v + "')").show();
  });

  jQuery('#jv-lvmlogcancelbtn').click(function() {
    var lines = [];
    jQuery('#jv-lvmbdrloghost input[type="checkbox"]:checked').each(function(i, e) {
      var pnode = jQuery(e).closest('tr');
      lines.push(+pnode.attr('line'));
    })
    th_alertWindowFn({
      tips: UNAS._("Are you sure to delete the selected log?")
    }, function() {
      lvmrep_log_clear(lines);
    })

  })

  jQuery("#jv-lvmbdrloghostcontent").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

})
