var lvmsnapshot_tasktimer = null;
var lvmsnapshot_tasknamelist = [];

function lvmsnapshot_mission_alload() {
  clearTimeout(lvmsnapshot_tasktimer);
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/wmi/index.php',
      data: JSON.encode({
        "token": UToken,
        "cmd": 'lv_snap_tasks'
      }),
      type: "post",
      dataType: "json",
      contentType: 'application/json',
      timeout: 30000,
      success: function(res) {
        lvmsnapshot_tasknamelist = [];
        if (res.err == 0) {
          var task = res.results.task || {};
          var records = [];
          for (var v in task) {
            if (task.hasOwnProperty(v)) {
              records.push(task[v]);
            }
          }

          jQuery('#jv-replications_list_lvm').empty();
          for (var i = 0; i < records.length; i++) {
            var tp_r = records[i];
            lvmsnapshot_tasknamelist.push(tp_r.taskname.toLowerCase());

            if ((snapshot_zfilesysname != tp_r.lv)) {
              continue;
            }

            var taskdom = lvmTemplateAppend('#jv-replications_list_lvm', 'jvt-taskitem_snapshot', 'jvt-taskitem_snapshot-' + i);
            taskdom.find('.bdrtask-taskitem').data('taskinfo', tp_r);
            taskdom.find('.taskname').text(tp_r.taskname || '--');
            taskdom.find('.dataset').text(tp_r.vg + '/' + tp_r.lv);
            if (tp_r.ssh_server) {
              var path = tp_r.ssh_server + ':' + tp_r.ssh_port + '/' + tp_r.ssh_target_vg;
              taskdom.find('.sendtask').text(path || '--');
            } else {
              taskdom.find('.sendtask').text(tp_r.target_dir || '--');
            }
            var schedulestxt = [];
            tp_r.cron = tp_r.cron || [];
            if (tp_r.cron.length) {
              for (var s = 0; s < tp_r.cron.length; s++) {
                var t_s = tp_r.cron[s];
                schedulestxt.push(lvmsnapshot_setSendTime(t_s));
              }
              taskdom.find('.schedule').html(schedulestxt[0]);
              var h = '';
              for (var j = 0; j < schedulestxt.length; j++) {
                h += '<li>' + schedulestxt[j] + '</li>';
              }
              taskdom.find('.jvc-sls').html(h);
              if (tp_r.cron.length > 1) {
                taskdom.find('.schedulenub').text(tp_r.cron.length).show();
              }

              taskdom.find('.schedulenub').on('mouseenter', function() {
                jQuery(this).parent().siblings('.schedulenublist').show();
              }).on('mouseleave', function() {
                jQuery(this).parent().siblings('.schedulenublist').hide();
              })

            } else {
              taskdom.find('.schedule').text('Nil');
              taskdom.find('.schedulenub').text(0).hide();
            }

            taskdom.find('.edit-taskicon').on('click', function() {
              var pnode = jQuery(this).closest('div.bdrtask-taskitem');
              var taskinfo = pnode.data('taskinfo');
              createlvmTaskWin(taskinfo, 'edit');
            });

            taskdom.find('.start-taskicon').on('click', function() {
              var pnode = jQuery(this).closest('div.bdrtask-taskitem');
              var taskinfo = pnode.data('taskinfo');
              var type = jQuery(this).attr('type');
              putlvmsnaptask(taskinfo.id, type);
            });

            taskdom.find('.unas_icon_delete').on('click', function() {
              var pnode = jQuery(this).closest('div.bdrtask-taskitem');
              var taskinfo = pnode.data('taskinfo');
              th_alertWindowFn({
                tips: UNAS._("Confirm to delete task") + '：' + taskinfo.taskname + ' ?'
              }, function() {
                putlvmsnaptask(taskinfo.id, 'delete');
              })
            });
          }
        }
        lvmTranslator('jv-replications_list_lvm');
      },
      complete: function(xml) {
        resolve(xml);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        reject(XMLHttpRequest);
      }
    })
  }).then(function() {
    lvmsnapshot_updatetaskrate();
  })
}

function lvmsnapshot_updatetaskrate() {
  clearTimeout(lvmsnapshot_tasktimer);
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.encode({
      "token": UToken,
      "cmd": 'lv_snap_tasks'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var taskdom = jQuery('#jv-replications_list_lvm').children();
      if (res.err == 0) {
        var run = res.results.run || {};
        var clone = run.clone || {};
        var records = [];
        for (var v in clone) {
          if (clone.hasOwnProperty(v)) {
            records.push(clone[v]);
          }
        }
        var capacity = currlvinfo.capacity * 1024 * 1024;
        for (var j = 0; j < taskdom.length; j++) {
          var t_dom = jQuery(taskdom[j]).find('.bdrtask-taskitem');
          var taskinfo = t_dom.data('taskinfo');
          t_dom.find('.tasknametitle').addClass('tasknametitle-1').removeClass('tasknametitle-0');
          t_dom.find('.start-taskicon').attr('type', 'start').removeClass('stop-taskicon');
          t_dom.find('.taskstate').text(UNAS._('##$@lvm@$##Completed##$@lvm@$##'));
          t_dom.find('.taskstate').addClass('taskstate-2').removeClass('taskstate-0');
          t_dom.find('.unas_icon_delete').removeClass('layui-disabled');
          t_dom.find('.bar-w').css('width', '0%');
          t_dom.find('.jcv-speed').text('--');
          t_dom.find('.percent_txt').text('');

          for (var i = 0; i < records.length; i++) {
            var t_s = records[i];
            var stat = t_s.stat || [];
            if (t_s.taskname == taskinfo.taskname) {
              var rate = parseInt((stat[0] / capacity) * 100) || 0;
              if (stat.length) {
                t_dom.find('.taskstate').text(UNAS._('##$@lvm@$##In Progress##$@lvm@$##'));
                t_dom.find('.taskstate').addClass('taskstate-0').removeClass('taskstate-2');
                t_dom.find('.tasknametitle').addClass('tasknametitle-0').removeClass('tasknametitle-1');
                t_dom.find('.edit-taskicon').addClass('layui-disabled');
                t_dom.find('.unas_icon_delete').addClass('layui-disabled');
                t_dom.find('.percent_txt').text(rate + '%');
                t_dom.find('.bar-w').css('width', rate + '%');
                t_dom.find('.jcv-speed').text(stat[2] + stat[3]);
                t_dom.find('.start-taskicon').attr('type', 'stop').addClass('stop-taskicon');
              } else {
                // t_dom.find('.taskstate').text(UNAS._('##$@lvm@$##Completed##$@lvm@$##'));
                // t_dom.find('.taskstate').addClass('taskstate-2').removeClass('taskstate-0');
                // t_dom.find('.tasknametitle').addClass('tasknametitle-1').removeClass('tasknametitle-0');
                // t_dom.find('.edit-taskicon').removeClass('layui-disabled');
                // t_dom.find('.unas_icon_delete').removeClass('layui-disabled');
                // if (t_s.finishedtime) {
                //   t_dom.find('.percent_txt').text(t_s.finishedtime);
                // } else {
                //   t_dom.find('.percent_txt').text('');
                // }
                // t_dom.find('.bar-w').css('width', '0%');
                // t_dom.find('.jcv-speed').text('--');
              }
            }
          }
        }
      }
    },
    complete: function(xml) {
      var taskdom = jQuery('#jv-replications_list_lvm').children();
      var taskhosthidden = jQuery('#zfs_snapshot_replication_container').is(':hidden');
      if (taskdom.length && !taskhosthidden) {
        lvmsnapshot_tasktimer = setTimeout(function() {
          lvmsnapshot_updatetaskrate();
        }, 2000);
      } else {
        clearTimeout(lvmsnapshot_tasktimer);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function putlvmsnaptask(id, act) {
  // start|stop|delete
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'lv_snap_task',
      "params": {
        "type" : "clone",
        "id" : id,
        "act" : act,
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      lvmsnapshot_mission_alload();
    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function lvmsnapshot_setSendTime(time) {
  var h = time[1];
  var m = time[0];
  var w_i = time[4];
  var days = time[2];
  var weekArray = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
  var week = weekArray[w_i];
  var timetext = '';
  if (w_i && w_i != '*') {
    timetext = '<span>' + week + '</span>' + ' ' + addTimeZero_lvmsnapshot(h) + ':' + addTimeZero_lvmsnapshot(m);
  } else if (days && days != '*') {
    timetext = '<span>Monthly</span>' + ' ' + days + '<span>st</span>' + ' ' + addTimeZero_lvmsnapshot(h) + ':' + addTimeZero_lvmsnapshot(m);
  } else {
    timetext = '<span>Daily</span>' + ' ' + addTimeZero_lvmsnapshot(h) + ':' + addTimeZero_lvmsnapshot(m);
  }
  return timetext;
}

function addTimeZero_lvmsnapshot(num) {
  return num >= 10 ? num : '0' + num;
}
